include:
  - project: 'twistersfury/devops/ci-cd-configuration'
    ref: 'v4.3.1'
    file:
      - '/global/global.yml'

.downstream-variables: &downstream-variables
  variables:
    APP_VERSION: $APP_VERSION

    VERSION: $APP_VERSION

    GitVersion_FullSemVer: $GitVersion_FullSemVer
    GitVersion_Major: $GitVersion_Major
    GitVersion_MajorMinorPatch: $GitVersion_MajorMinorPatch
    GitVersion_Minor: $GitVersion_Minor
    GitVersion_Patch: $GitVersion_Patch
    GitVersion_PreReleaseLabel: $GitVersion_PreReleaseLabel
    GitVersion_PreReleaseNumber: $GitVersion_PreReleaseNumber
    GitVersion_SemVer: $GitVersion_SemVer

    TF_UPSTREAM: "true"
    TF_UPSTREAM_BRANCH: $CI_COMMIT_REF_NAME
    TF_UPSTREAM_PROJECT: $CI_PROJECT_PATH

Generate Version Number:
  extends:
    .tf-git-version
  stage: Build Version

Build Image:
  <<: *downstream-variables
  stage: Downstream Pipelines - Build
  trigger:
    include: '.gitlab-ci/docker/cpp.yml'
    strategy: depend

Update Helm Charts:
  <<: *downstream-variables
  stage: Downstream Pipelines - Test
  trigger:
    include: '.gitlab-ci/helm.yml'
    strategy: depend

Upload To Rancher:
  <<: *downstream-variables
  stage: Downstream Pipelines - Deploy
  rules:
    -   if: '$CI_COMMIT_BRANCH && $CI_COMMIT_REF_PROTECTED != "false"'
  trigger:
    include: '.gitlab-ci/publish.yml'
    strategy: depend

